#ifndef OF_LHEF_H
#define OF_LHEF_H

#include "OutputFormat.h"
#include "LHEF.h"

namespace SANC {

class Info;
class Process;
class LHEF;

class OF_LHEF : public OutputFormat {
public:
    OF_LHEF(Info & _info, Process & _proc);
    ~OF_LHEF(){}
    void setOutput(std::ostream * _output);
    void start();
    void writeEvent(/*Event*/);
    void finish();
private:
    LHEF lhef;
    std::ostream * output = nullptr;
};

} // namespace SANC

#endif // OF_LHEF_H